Subject: Re: [PATCHv4 2/4] Add infrastructure for ref namespaces

From: Josh Triplett <[email-masked]>
Date: Wed, 8 Jun 2011 20:38:17 -0700

On Wed, Jun 08, 2011 at 11:41:25AM +0200, Jakub Narebski wrote:
> On Fri, 3 June 2011, Josh Triplett wrote:
> > On Fri, Jun 03, 2011 at 01:35:34AM -0700, Jakub Narebski wrote:
> > > Jamey Sharp <[email-masked]> writes:
> > > 
> > > > From: Josh Triplett <[email-masked]>
> > > > 
> > > > Add support for dividing the refs of a single repository into multiple
> > > > namespaces, each of which can have its own branches, tags, and HEAD.
> > > > Git can expose each namespace as an independent repository to pull from
> > > > and push to, while sharing the object store, and exposing all the refs
> > > > to operations such as git-gc.
> > > [...]
> > > 
> > > By the way, after this feature is merged in, would you like for gitweb
> > > to understand ref namespaces and offer browsing of separate namespaces
> > > (sub-repositories)?
> > 
> > Yes, definitely!  We'd love to see gitweb handling namespaces
> > transparently, and presenting them identically to top-level
> > repositories.  (Also, gitweb would need to present the appropriate
> > repository URIs for cloning.)
> 
> Note that for gitweb support we would need some easy way to list all
> namespaces that given repository provides.  But that is for the future.
> 
> BTW. what do you think about treating repository with own refs and with
> namespaces similarly to how "forks" are handled in gitweb now?

Different namespaces won't necessarily represent forks of the same
repository; they may represent entirely separate repositories, with the
use of namespaces merely a server-side implementation detail to save
space.  I'd suggest presenting them as separate repositories.

- Josh Triplett